﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Globalization;

namespace howto_interest_by_days
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            // Get inputs.
            DateTime start_date = DateTime.Parse(txtStartDate.Text);
            DateTime end_date = DateTime.Parse(txtEndDate.Text);

            string ann_interest_string = txtAnnualPercent.Text;
            if (ann_interest_string.Contains("%"))
                ann_interest_string = ann_interest_string.Replace("%", "");
            decimal annual_rate = decimal.Parse(ann_interest_string);
            if (annual_rate >= 0.5m)
                annual_rate /= 100m;

            decimal principle =
                decimal.Parse(txtPrinciple.Text, NumberStyles.Any);

            // Redisplay the inputs to make sure they're correct.
            txtStartDate.Text = start_date.ToShortDateString();
            txtEndDate.Text = end_date.ToShortDateString();
            txtAnnualPercent.Text = annual_rate.ToString("P");
            txtPrinciple.Text = principle.ToString("C");

            // Calculate the number of days in a "year."


            // Calculate simple interest.
            TimeSpan elapsed = end_date - start_date;
            int days = (int)elapsed.TotalDays;
            decimal daily_rate = annual_rate / 365m ;
            decimal simple_interest = days * daily_rate * principle;
            decimal simple_total = principle + simple_interest;

            // Calculate interest compounded daily.
            decimal daily_total = principle *
                (decimal)Math.Pow(1 + (double)daily_rate, days);
            decimal daily_interest = daily_total - principle;

            // Calculate interest compounded continuously.
            decimal continuous_total = principle *
                (decimal)Math.Pow(Math.E, (double)daily_rate * days);
            decimal continuous_interest = continuous_total - principle;

            // Display results.
            Console.WriteLine("# Days: " + days.ToString());
            txtSimple.Text = simple_interest.ToString("C");
            txtSimpleTotal.Text = simple_total.ToString("C");

            txtDaily.Text = daily_interest.ToString("C");
            txtDailyTotal.Text = daily_total.ToString("C");

            txtContinuously.Text = continuous_interest.ToString("C");
            txtContinuousTotal.Text = continuous_total.ToString("C");
        }
    }
}
